javax.jms

## Interface MessageConsumer

- All Superinterfaces:
    AutoCloseable
  All Known Subinterfaces:
    QueueReceiver, TopicSubscriber

      public interface MessageConsumer
      extends AutoCloseable

  A client uses a `MessageConsumer` object to receive messages from a destination. A `MessageConsumer` object is created by passing a `Destination` object to a message-consumer creation method supplied by a session.

  `MessageConsumer` is the parent interface for all message consumers.

  A `MessageConsumer` can be created with a message selector. A message selector allows the client to restrict the messages delivered to the message consumer to those that match the selector.

  A client may either synchronously receive a `MessageConsumer`'s messages or have the `MessageConsumer` asynchronously deliver them as they arrive.

  For synchronous receipt, a client can request the next message from a `MessageConsumer` using one of its `receive` methods. There are several variations of `receive` that allow a client to poll or wait for the next message.

  For asynchronous delivery, a client can register a `MessageListener` object with a `MessageConsumer`. As messages arrive at the `MessageConsumer`, it delivers them by calling the `MessageListener`'s `onMessage` method.

  It is a client programming error for a `MessageListener` to throw an exception.

  Since:
    JMS 1.0
  Version:
    JMS 2.0
  See Also:
    `QueueReceiver`, `TopicSubscriber`, `Session`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the message consumer.
    `MessageListener` | `getMessageListener()` Gets the `MessageConsumer`'s `MessageListener`.
    `String` | `getMessageSelector()` Gets this message consumer's message selector expression.
    `Message` | `receive()` Receives the next message produced for this message consumer.
    `Message` | `receive(long timeout)` Receives the next message that arrives within the specified timeout interval.
    `Message` | `receiveNoWait()` Receives the next message if one is immediately available.
    `void` | `setMessageListener(MessageListener listener)` Sets the `MessageConsumer`'s `MessageListener`.

- - ### Method Detail

    - #### getMessageSelector

          String getMessageSelector()
                                    throws JMSException

      Gets this message consumer's message selector expression.
      Returns:
        this message consumer's message selector, or null if no message selector exists for the message consumer (that is, if the message selector was not set or was set to null or the empty string)
      Throws:
        `JMSException` - if the JMS provider fails to get the message selector due to some internal error.

    - #### getMessageListener

          MessageListener getMessageListener()
                                             throws JMSException

      Gets the `MessageConsumer`'s `MessageListener`.

      This method must not be used in a Java EE web or EJB application. Doing so may cause a `JMSException` to be thrown though this is not guaranteed.

      Returns:
        the `MessageConsumer`'s `MessageListener`, or null if one was not set
      Throws:
        `JMSException` - if the JMS provider fails to get the `MessageListener` for one of the following reasons:
        - an internal error has occurred or
        - this method has been called in a Java EE web or EJB application (though it is not guaranteed that an exception is thrown in this case)
      See Also:
        `setMessageListener(javax.jms.MessageListener)`

    - #### setMessageListener

          void setMessageListener(MessageListener listener)
                                  throws JMSException

      Sets the `MessageConsumer`'s `MessageListener`.

      Setting the the `MessageListener` to null is the equivalent of unsetting the `MessageListener` for the `MessageConsumer`.

      The effect of calling this method while messages are being consumed by an existing listener or the `MessageConsumer` is being used to consume messages synchronously is undefined.

      This method must not be used in a Java EE web or EJB application. Doing so may cause a `JMSException` to be thrown though this is not guaranteed.

      Parameters:
        `listener` - the listener to which the messages are to be delivered
      Throws:
        `JMSException` - if the JMS provider fails to set the `MessageConsumer`'s `MessageListener` for one of the following reasons:
        - an internal error has occurred or
        - this method has been called in a Java EE web or EJB application (though it is not guaranteed that an exception is thrown in this case)
      See Also:
        `getMessageListener()`

    - #### receive

          Message receive()
                          throws JMSException

      Receives the next message produced for this message consumer.

      This call blocks indefinitely until a message is produced or until this message consumer is closed.

      If this `receive` is done within a transaction, the consumer retains the message until the transaction commits.

      Returns:
        the next message produced for this message consumer, or null if this message consumer is concurrently closed
      Throws:
        `JMSException` - if the JMS provider fails to receive the next message due to some internal error.

    - #### receive

          Message receive(long timeout)
                          throws JMSException

      Receives the next message that arrives within the specified timeout interval.

      This call blocks until a message arrives, the timeout expires, or this message consumer is closed. A `timeout` of zero never expires, and the call blocks indefinitely.

      Parameters:
        `timeout` - the timeout value (in milliseconds)
      Returns:
        the next message produced for this message consumer, or null if the timeout expires or this message consumer is concurrently closed
      Throws:
        `JMSException` - if the JMS provider fails to receive the next message due to some internal error.

    - #### receiveNoWait

          Message receiveNoWait()
                                throws JMSException

      Receives the next message if one is immediately available.
      Returns:
        the next message produced for this message consumer, or null if one is not available
      Throws:
        `JMSException` - if the JMS provider fails to receive the next message due to some internal error.

    - #### close

          void close()
                     throws JMSException

      Closes the message consumer.

      Since a provider may allocate some resources on behalf of a `MessageConsumer` outside the Java virtual machine, clients should close them when they are not needed. Relying on garbage collection to eventually reclaim these resources may not be timely enough.

      This call will block until a `receive` call in progress on this consumer has completed. A blocked `receive` call returns null when this message consumer is closed.

      If this method is called whilst a message listener is in progress in another thread then it will block until the message listener has completed.

      This method may be called from a message listener's `onMessage` method on its own consumer. After this method returns the `onMessage` method will be allowed to complete normally.

      This method is the only `MessageConsumer` method that can be called concurrently.

      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `JMSException` - if the JMS provider fails to close the consumer due to some internal error.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.